let indextoperif8266 = ["D0","D1","D2","D3","D4","D5","D6","D7","D8","RX","TX","A0","","","","RGB","","","","","","I1","I2","I3","I4","I5","I6","I7","I8","","","RE1","RE2","RE3","RE4","RE5","RE6","RE7","RE8","RE9","RE10","RE11","RE12","","","","","","","","","MEM1","MEM2","MEM3","MEM4","MEM5","MEM6","MEM7","MEM8","MEM9","MEM10"];
let validGPIO = new Array();
let anlgGPIO = new Array();
let tchiGPIO = new Array();
let _GPIOs = 50;
let _perprefix = "";


function setglobals(chip){
  if(chip=="ESP8266"){
  _GPIOs = 9;
  _perprefix = "";
  anlgGPIO = [ true, true, true, true, true, true, true, true, true,false,false, true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  tchiGPIO = [ true, true, true, true, true, true, true, true, true,false,false, true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  validGPIO= [ true, true, true, true, true, true, true, true, true,false,false, true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  //              0     1     2     3     4     5     6     7     8    RX    TX    11
  } else if(chip=="ESP32"){
  _GPIOs = 40;
  _perprefix = "IO";
  anlgGPIO = [false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false, true, true, true, true, true, true, true, true,false,false,false,false,false,false,false,false,false,false];
  tchiGPIO = [ true,false, true,false, true,false,false,false,false,false,false,false, true, true, true, true,false,false,false,false,false,false,false,false,false,false,false, true,false,false,false,false, true, true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  validGPIO= [ true,false, true,false, true, true,false,false,false,false,false,false, true, true, true, true, true, true, true, true,false, true, true, true,false, true, true, true,false,false,false,false, true, true, true, true, true, true, true, true,false,false,false,false,false,false,false,false,false,false];
  //              0    TX     2    RX     4     5   <************  SPI  ************>    12    13    14    15    16    17    18    19     X    21    22    23     X    25    26    27     X     X     X     X    32    33    34    35    36    37    38    39
  } else if(chip=="ESP32-S2"){
  _GPIOs = 47;
  _perprefix = "IO";
  anlgGPIO = [false, true, true, true, true, true, true, true, true, true, true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  tchiGPIO = [false, true, true, true, true, true, true, true, true, true, true, true, true, true, true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  validGPIO= [ true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true,false,false,false,false,false,false,false,false,false,false,false, true, true, true, true, true, true, true, true, true, true,false,false, true, true,false,false,false];
  //              0     1     2     3     4     5     6     7     8     9    10    11    12    13    14    15    16    17    18    19    20    21     X     X     X     X     X   <************  SPI  ************>    33    34    35    36    37    38    39    40    41    42    TX    RX    45    46
  } else if(chip=="ESP32-S3"){
  _GPIOs = 49;
  _perprefix = "IO";
  anlgGPIO = [false, true, true, true, true, true, true, true, true, true, true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  tchiGPIO = [false, true, true, true, true, true, true, true, true, true, true, true, true, true, true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  validGPIO= [ true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true,false,false,false,false,false,false,false,false,false,false,false, true, true, true, true, true, true, true, true, true, true,false,false, true, true, true, true,false];
  //              0     1     2     3     4     5     6     7     8     9    10    11    12    13    14    15    16    17    18    19    20    21     X     X     X     X     X   <************  SPI  ************>    33    34    35    36    37    38    39    40    41    42    TX    RX    45    46    47    48
  } else if(chip=="ESP32-C2"){
  _GPIOs = 21;
  _perprefix = "IO";
  anlgGPIO = [ true, true, true, true, true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  tchiGPIO = [false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  validGPIO= [ true, true, true, true, true, true, true, true, true, true, true,false,false,false,false,false,false,false, true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  //              0     1     2     3     4     5     6     7     8     9    10     X   <************  SPI  ************>    18    RX    TX
  } else if(chip=="ESP32-C3"){
  _GPIOs = 22;
  _perprefix = "io";
  anlgGPIO = [ true, true, true, true, true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  tchiGPIO = [false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  validGPIO= [ true, true, true, true, true, true, true, true, true, true, true,false,false,false,false,false,false,false, true, true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false];
  //              0     1     2     3     4     5     6     7     8     9    10     X   <************  SPI  ************>    18    19    RX    TX
  }
}
