var page = "system";
var jsontext;
var ntp = document.getElementById("ntp");
var ram = document.getElementById("ram");
var system = document.getElementById("system");
var mqtt = document.getElementById("mqtt");
var mqttup = document.getElementById("mqttup");
var chip = document.getElementById("chip");
var systemup = document.getElementById("systemup");
var wifiup = document.getElementById("wifiup");
var pass_input = document.getElementById("pass");
var proc_input = document.getElementById("start");
var settingsfile = document.getElementById("settingsfile");
var update_popup = document.getElementById("update_popup");
var factory = document.getElementById("factory");
var keepwifi = document.getElementById("keepwifi");
var keepwifilabel = document.getElementById("keepwifilabel");

function tech_topics() {
   var eepr = new XMLHttpRequest();
   var url = "http:\\\\"+ip+"\\proc_topics?proc_id=1";
          eepr.open("GET", url, true);
          eepr.setRequestHeader('Content-type', 'text/plain');
          eepr.withCredentials = conn_auth;
	  eepr.send();
          eepr.onreadystatechange = function() {
              if (this.readyState == 4 && this.status == 200) {
                const load = JSON.parse(this.responseText);
                document.getElementById("tech_mqtt_on").innerHTML=load.root+"/pub/conn";
                document.getElementById("tech_mqtt_rssi").innerHTML=load.root+"/pub/rssi";
                document.getElementById("tech_mqtt_ip").innerHTML=load.root+"/pub/ip";
                }
              };
}

function exportstring_load(){
      const load = JSON.parse(jsontext);
      mqtt.innerHTML = load.mqtt;
      mqttup.innerHTML = load.mqttup;
      ntp.innerHTML = load.ntp;
      ram.innerHTML = load.ram;
      system.innerHTML = load.system;
      chip.innerHTML = chipfamily;
      systemup.innerHTML = load.systemup;
      wifiup.innerHTML = load.wifiup;
      if(load.mqtt!="No") tech_topics();
    }

function batch_load() {}
batch_load();

function unicontrol_export_device(){
   var eepr = new XMLHttpRequest();
   var url = "http:\\\\"+ip+"\\settings_export?pass=" + pass_input.checked;
   eepr.open("GET", url, true);
   eepr.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
   eepr.withCredentials = conn_auth;
   eepr.send();
   eepr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            var today = new Date();
            var day = String(today.getDate()).padStart(2, '0');
            var month = String(today.getMonth() + 1).padStart(2, '0');
            var year = today.getFullYear();
            const exportdata = document.createElement("a");
            exportdata.href = URL.createObjectURL(new Blob([this.responseText], {type: "text/plain"}));
            exportdata.setAttribute("download", "unicontrol_backup_device_"+activename.innerHTML+"_"+year+"-"+month+"-"+day+".aya");
            document.body.appendChild(exportdata);
            exportdata.click();
            document.body.removeChild(exportdata);
        }
   };
}

function unicontrol_export_proc(){
   var eepr = new XMLHttpRequest();
   var procfrom = proc_input.value;
   var url = "http:\\\\"+ip+"\\processes_export?procfrom="+procfrom;
   eepr.open("GET", url, true);
   eepr.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
   eepr.withCredentials = conn_auth;
   eepr.send();
   eepr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            const load = JSON.parse(this.responseText);
            var today = new Date();
            var day = String(today.getDate()).padStart(2, '0');
            var month = String(today.getMonth() + 1).padStart(2, '0');
            var year = today.getFullYear();
            const exportdata = document.createElement("a");
            exportdata.href = URL.createObjectURL(new Blob([this.responseText], {type: "text/plain"}));
            var filesuffix="";
            if(load.procfrom != 1 || load.procto != sys_procs) filesuffix="_"+load.procfrom+"-"+load.procto;
            exportdata.setAttribute("download", "unicontrol_backup_processes_"+activename.innerHTML+"_"+year+"-"+month+"-"+day+filesuffix+".aya");
            document.body.appendChild(exportdata);
            exportdata.click();
            document.body.removeChild(exportdata);
        }
   };
}

function unicontrol_import_send(data){
   const content = JSON.parse(data);
   var url;
   if(content.data=="processes") {url = "http:\\\\"+ip+"\\processes_import?factory=" + factory.checked;}
   else if(content.data=="device") {url = "http:\\\\"+ip+"\\settings_import?factory=" + factory.checked + "&keepwifi=" + keepwifi.checked;}
   else {alert("Invalid file"); return;}

   var eepr = new XMLHttpRequest();
   eepr.open("POST", url, true);
   eepr.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
   eepr.withCredentials = conn_auth;
   eepr.send(data);
   document.body.classList.add("wait-cursor");
   eepr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            if(content.data=="processes") alert("Processes loaded successfully!");
            if(content.data=="device")    alert("Device settings loaded successfully!");
            document.body.classList.remove("wait-cursor");
            factory.checked = false;
            keepwifi.checked = false;
            }
        else if (this.readyState == 4 && this.status == 400) {
            alert("Import failed!");
            document.body.classList.remove("wait-cursor");
            }
   };
}


function unicontrol_import(file){
  if(settingsfile.value==""){
        alert("You must choose a valid backup file!");
      } else {
        const file = settingsfile.files[0];
        const reader = new FileReader();
        reader.addEventListener("load", () => {unicontrol_import_send(reader.result);}, false);
        reader.readAsText(file);
      }
}


function flush(){
      ntp.innerHTML = "";
      ram.innerHTML = "";
      system.innerHTML = "";
      mqtt.innerHTML = "";
      mqttup.innerHTML = "";
      systemup.innerHTML = "";
      wifiup.innerHTML = "";
      pass_input.checked = false;
}

function contentfilter(){
    if(sys_version<latest_sys_version){
        document.getElementById('update_popup').classList.remove("hidden");
        document.getElementById('update_button').innerHTML="Update to version "+latest_sys_version;
        }
}
function data_load() {}
